from readmdict import MDX
from bs4 import BeautifulSoup
from htmlmin import minify

filenames = [
	'Cambridge',
	'Collins',
	'DictionOL',
	'Longman',
	'Macmillan',
	'Oxford',
	'VocabOL',
	'Australia',
]
at_at_links = {}
additional_jumps = {}
more_additional_jumps ={}
last_jumps = {}
data_tuple = {}

for filename in filenames:
	mdx = MDX(filename + '.mdx')

	keys_dct = {}
	for Key,Value in mdx.items():
		Key = Key.strip()
		Key = Key.lower()
		if Value[:8].lower() != b'@@@link=':
			keys_dct[Key] = b'1'

	temp_diction = {}
	for Key,Value in mdx.items():
		Key = Key.strip()
		Key = Key.lower()
		Value = Value.strip()
		if Value[:8].lower() != b'@@@link=':
			try:
				temp_diction[Key] += Value
			except:
				temp_diction[Key] = Value
		else:
			try:
				keys_dct[Key]
			except:
				temp_diction[Key] = Value

	T = len(temp_diction)
	div = 5
	if div > T:
		print('divertion error')
	accum = 1
	percentage = 100//div
	for Key,Value in temp_diction.items():
		if accum % (T // div) ==0:
			print('done:',percentage,'%')
			percentage += 100//div
		accum += 1
		Value = Value.strip()

		if Value[:8].lower() != b'@@@link=':

			if filename == 'Cambridge':
				Value = Value.replace(b'href=sound://uk_pron/',b'href=sound://Cambridge/')
			elif filename == 'Collins':
				Value = Value.replace(b'href=sound://COLmp3/',b'href=sound://Collins/')
			elif filename == 'DictionOL':
				Value = Value.replace(b'href=sound://',b'href=sound://DictionOL/')
			elif filename == 'Longman':
				Value = Value.replace(b'href=sound://media/english/',b'href=sound://Longman/')
				Value = Value.replace(b'href=sound://media/spx/',b'href=sound://Longman/spx/')
			elif filename == 'Macmillan':
				Value = Value.replace(b'href=sound://',b'href=sound://Macmillan/')
			elif filename == 'Oxford':
				Value = Value.replace(b'href=sound://pron/',b'href=sound://Oxford/')
			elif filename == 'VocabOL':
				Value = Value.replace(b'href=sound://',b'href=sound://VocabOL/')
			elif filename == 'Australia':
				Value = Value.replace(b'href=sound://',b'href=sound://Australia/')

			wanted = b'<div class=' + filename.encode() + b'>' + Value + b'</div>'
			try:
				X = data_tuple[Key]
				X.append((wanted,))
			except:
				data_tuple[Key] = [(wanted,),]
		else:
			Value = Value[8:].lower()
			try:
				at_at_links[Key]
				has_jump = True
			except:
				has_jump = False
				at_at_links[Key] = Value
			if has_jump and has_jump != Value:
				try:
					has_addition_jump = additional_jumps[Key]
				except:
					has_addition_jump = False
				if has_addition_jump and has_addition_jump != Value:
					try:
						has_more_additional_jump = more_additional_jumps[Key]
					except:
						more_additional_jumps[Key] = Value
						has_more_additional_jump = False
					if has_more_additional_jump and has_more_additional_jump != Value:
						print('- - -',filename,Key,has_more_additional_jump,Value)#Macmillan b'pokiest' b'poky' b'pokey'
						last_jumps[Key] = Value
				else:
					additional_jumps[Key] = Value
	print('Done:' + filename)

all_jumps = []
for X,Y in at_at_links.items():
	if X != Y:
		all_jumps.append((X,Y,))
for X,Y in additional_jumps.items():
	if X != Y:
		all_jumps.append((X,Y,))
for X,Y in more_additional_jumps.items():
	if X != Y:
		all_jumps.append((X,Y,))
for X,Y in last_jumps.items():
	if X != Y:
		all_jumps.append((X,Y,))
availble_jumps = []
for X,Y in all_jumps:
	try:
		data_tuple[X]
	except:
		availble_jumps.append((X,Y,))
none_repeat_jumps = []
T = len(availble_jumps)
div = 100
if div > T:
	print('divertion error')
accum = 1
percentage = 100//div
print('Start removing repeat-jump(s)')
for X,Y in availble_jumps:
	if accum % (T // div) ==0:
		print('done:',percentage,'%')
		percentage += 100//div
	accum += 1

	if (X,Y,) not in none_repeat_jumps:
		none_repeat_jumps.append((X,Y,))

if data_tuple:
	pre_datum = b'<link href=phonetics.css rel=stylesheet>'
	at_at_s = b'@@@LINK='
	with open('1_combine_.txt','wb') as fyle:
		ordered = sorted(data_tuple.items())
		for X in ordered:
			fyle.write(X[0] + b'\r\n')
			fyle.write(pre_datum)
			for y in X[1]:
				if y is not X[1][-1]:
					fyle.write(y[0])
				else:
					fyle.write(y[0] + b'\r\n</>\r\n')
		for X in none_repeat_jumps:
			if X is none_repeat_jumps[-1]:
				fyle.write(X[0] + b'\r\n' + (at_at_s + X[1]) + b'\r\n</>')
			else:
				fyle.write(X[0] + b'\r\n' + (at_at_s + X[1]) + b'\r\n</>\r\n')
