from readmdict import MDX
from bs4 import BeautifulSoup
import os,shutil

filenames = [
	'Cambridge',
	'Collins',
	'DictionOL',
	'Longman',
	'Macmillan',
	'Oxford',
	'VocabOL',
	'Australia',
]

def tocopy (val,file_name):
	bso = BeautifulSoup(val.decode(),'lxml')
	for X in bso.select('a'):
		attrs = X.attrs
		y = attrs['href'][8:]
		z = y.replace('/','\\')
		source_file = '.\\' + file_name +'\\' + z
		destinate_file = '.' + '\\_Audios_in_use_\\' + file_name +'\\' + z
		destinate_folder = os.path.dirname(destinate_file)
		if os.path.isfile(source_file):
			if not os.path.isfile(destinate_file):
				if not os.path.exists(destinate_folder):
					os.makedirs(destinate_folder)
				shutil.copy2(source_file,destinate_folder)

for filename in filenames:
	mdx = MDX(filename + '.mdx')

	T = len(mdx)
	div = 10
	if div > T:
		print('divertion error')
	accum = 1
	percentage = 100//div

	for Key,Value in mdx.items():
		if accum % (T // div) ==0:
			print('done:',percentage,'%')
			percentage += 100//div
		accum += 1
		Value = Value.strip()

		if Value[:8].lower() != b'@@@link=':
			if filename == 'Cambridge':
				Value = Value.replace(b'href=sound://uk_pron/',b'href=sound://Cambridge/')
			elif filename == 'Collins':
				Value = Value.replace(b'href=sound://COLmp3/',b'href=sound://Collins/')
			elif filename == 'DictionOL':
				Value = Value.replace(b'href=sound://',b'href=sound://DictionOL/')
			elif filename == 'Longman':
				Value = Value.replace(b'href=sound://media/english/',b'href=sound://Longman/')
				Value = Value.replace(b'href=sound://media/spx/',b'href=sound://Longman/spx/')
			elif filename == 'Macmillan':
				Value = Value.replace(b'href=sound://',b'href=sound://Macmillan/')
			elif filename == 'Oxford':
				Value = Value.replace(b'href=sound://pron/',b'href=sound://Oxford/')
			elif filename == 'VocabOL':
				Value = Value.replace(b'href=sound://',b'href=sound://VocabOL/')
			elif filename == 'Australia':
				Value = Value.replace(b'href=sound://',b'href=sound://Australia/')
			tocopy(Value,filename)

	print('done:',filename)